#!/usr/bin/ruby

require 'pp'
require 'gnuplot'
require 'pathname'
require "optparse"

USAGE = "Usage: #{File.basename("#{__FILE__}")} [options]"

## option analysis
options = {}
op = OptionParser.new
op.banner = USAGE
op.on("-e" , "--eps" , "Output eps format, alternative to png format"){options[:eps] = true}
op.parse!(ARGV)

Gnuplot.open do |gp|
  Gnuplot::SPlot.new( gp ) do |plot|
    if options[:eps]
      plot.terminal "postscript eps enhanced color solid"
      plot.output   Pathname( __FILE__).sub_ext( ".eps").to_s
    else
      plot.terminal "png enhanced font 'IPA P ゴシック' fontscale 1.2"
      plot.output   Pathname( __FILE__).sub_ext( ".png").to_s
    end
    plot.output   Pathname( __FILE__).sub_ext( ".png").to_s
    plot.grid

    plot.data = [
      Gnuplot::DataSet.new( "x**2+y**2" ) do |ds|
      ds.with = "pm3d"
      end
    ]
  end
  #sleep 10
end
