#! /usr/bin/env ruby
# coding: utf-8

require 'pp'
#Amazon::Ecs.debug = true

#/home/ippei/.gem/ruby/2.3.0/gems/amazon-ecs-2.4.0/lib/amazon/ecs.rb:141:in `send_request': HTTP Response: 503 Service Unavailable (Amazon::RequestError)
#>---from /home/ippei/.gem/ruby/2.3.0/gems/amazon-ecs-2.4.0/lib/amazon/ecs.rb:102:in `item_search'
#>---from /home/ippei/.gem/ruby/2.3.0/gems/madowu-0.0.8/lib/madowu/isbn.rb:37:in `initialize'
#>---from /home/ippei/.gem/ruby/2.3.0/gems/madowu-0.0.8/bin/isbninfo:9:in `new'
#>---from /home/ippei/.gem/ruby/2.3.0/gems/madowu-0.0.8/bin/isbninfo:9:in `block in <top (required)>'
#>---from /home/ippei/.gem/ruby/2.3.0/gems/madowu-0.0.8/bin/isbninfo:8:in `each_line'
#>---from /home/ippei/.gem/ruby/2.3.0/gems/madowu-0.0.8/bin/isbninfo:8:in `each'
#>---from /home/ippei/.gem/ruby/2.3.0/gems/madowu-0.0.8/bin/isbninfo:8:in `<top (required)>'
#>---from /home/ippei/.gem/ruby/2.3.0/bin/isbninfo:22:in `load'
#>---from /home/ippei/.gem/ruby/2.3.0/bin/isbninfo:22:in `<main>'

#
#
#
class Madowu::BookInfo

  ROOT_KEY_FILE = ENV['HOME'] + '/.aws/rootkey.csv'
  ASSOCIATEID_FILE = ENV['HOME'] + '/.aws/associateid'

  attr_reader :title, :author, :isbn, :publisher, :publication_date,
   :url, :img_url

  class AccountFileError < StandardError; end

  def initialize(title: '',
                 author: '',
                 isbn: '',
                 publisher: '',
                 publication_date: '',
                 url: '',
                 img_url: '')
    @title            = title
    @author           = author
    @isbn             = isbn
    @publisher        = publisher
    @publication_date = publication_date
    @url              = url
    @img_url          = img_url
  end

  def self.load_isbn(isbn)
    [ROOT_KEY_FILE, ASSOCIATEID_FILE].each do |file|
      raise AccountFileError, "Not found #{file}" unless File.exist? file
    end

    hash = {}
    hash[:associate_tag] = File.open(ASSOCIATEID_FILE, 'r').gets.chomp
    File.open(ROOT_KEY_FILE, 'r').readlines.each do |i|
      /(.*)=(.*)/ =~ i
      key, val = $1, $2
      hash[:AWS_access_key_id] = val.chomp if key == 'AWSAccessKeyId'
      hash[:AWS_secret_key]    = val.chomp if key == 'AWSSecretKey'
    end
    Amazon::Ecs.options = hash

    info = nil
    3.times do |i|
      begin
        info = Amazon::Ecs.item_search(
          isbn,
          {:search_index => 'Books',
           :response_group => 'Medium',
           :country => 'jp'
          }
        )
        #pp i
        #pp info
      rescue Amazon::RequestError
        sleep 1
      end
      break if info
    end

    unless info
      raise Amazon::RequestError
    end

    properties = {}
    info.items.each do |item|
      properties[:title           ] = item.get('ItemAttributes/Title')
      properties[:author          ] = item.get('ItemAttributes/Author')
      properties[:isbn            ] = item.get('ItemAttributes/ISBN')
      properties[:publisher       ] = item.get('ItemAttributes/Publisher')
      properties[:publication_date] = item.get('ItemAttributes/PublicationDate')
      properties[:url             ] = item.get('DetailPageURL')
      properties[:img_url         ] = item.get('SmallImage/URL')
    end
    self.new(properties)
  end


end

